package FlowGraph;

import java.util.*;
import Graph.Node;
import Graph.NodeList;
import Temp.TempNode;

public class AssemFlowGraph extends FlowGraph
{
  private Hashtable ntoi;  //per associare ad ogni nodo la sua Instr
  private Hashtable iton;  //per associare ad ogni istr il nodo
  private Hashtable ltoi;  //per associare ad ogni label la istr
  private Hashtable in,out;   //per associare ad ogni nodo in e out
  private Assem.InstrNode instr;

  public AssemFlowGraph(Assem.InstrNode instrs)
  {
    ntoi=new Hashtable();
    iton=new Hashtable();
    ltoi=new Hashtable();
    in=new Hashtable();
    out=new Hashtable();
    instr=instrs;
    //inserimento nodi
    while(instrs!=null){
      Node act=newNode();
      iton.put(instrs.head,act);
      ntoi.put(act,instrs.head);
      if(instrs.head instanceof Assem.LABEL)
        ltoi.put( ((Assem.LABEL)instrs.head).label, instrs.head);
      in.put(act,new ArrayList());
      out.put(act,new ArrayList());
      instrs=instrs.tail;
    }
    //inserimento archi
    instrs=instr;
    while(instrs!=null){
      Node act=(Node)iton.get(instrs.head);
      Node next=null;
      if(instrs.tail!=null) next=(Node)iton.get(instrs.tail.head);
      if(next!=null) addEdge(act,next);
      if(instrs.head.jumps()!=null){
        Temp.LabelList ili=instrs.head.jumps().labels;
        while(ili!=null){
          Assem.Instr jmp=(Assem.Instr)ltoi.get(ili.head);
          if(jmp!=null){
            next=(Node)iton.get(jmp);
            addEdge(act,next);
          }
          ili=ili.tail;
        }
      }
      instrs=instrs.tail;
    }
    processInOut();
  }

   public void processInOut(){
    boolean chg=true;
    while(chg){
      chg=false;
      NodeList ln=nodes();
      while(ln!=null){
        Node act=ln.head;
        ArrayList aIN=(ArrayList)in.get(act);
        ArrayList aOUT=(ArrayList)out.get(act);
        //si assegna in[act]=use[act]U(out[act]-def[act])
        //use[n]
        Temp.TempNode uu=use(act);
        while(uu!=null){
          if((!aIN.contains(uu.head))&&(uu.head!=null)) {
            aIN.add(uu.head);
            chg=true;
          }
          uu=uu.tail;
        }
        //out[n]-def[n]
        for(int i=0;i<aOUT.size();i++){
          Temp.Temp p=(Temp.Temp)aOUT.get(i);
          if((!aIN.contains(p))&&(!contain(def(act),p))&&(p!=null)){
            aIN.add(p);
            chg=true;
          }
        }
        //si assegna a out[act]=U in[s] per s in succ[act]
        NodeList ss=act.succ();
        while(ss!=null){
          Node s=ss.head;
          ArrayList sIN=(ArrayList)in.get(s);
          for(int i=0;i<sIN.size();i++){
            Temp.Temp sa=(Temp.Temp)sIN.get(i);
            if((!aOUT.contains(sa))&&(sa!=null)){
                aOUT.add(sa);
                chg=true;
            }
          }
          ss=ss.tail;
        }
        ln=ln.tail;
      }
    }
  }

  public TempNode def(Node node){return optimize(((Assem.Instr)ntoi.get(node)).def());}

  public TempNode use(Node node){return optimize(((Assem.Instr)ntoi.get(node)).use());}

  public boolean isMove(Node node){return (getInstr(node)instanceof Assem.MOVE);}

  public TempNode in(Node n){return optimize(convertT((ArrayList)in.get(n)));}

  public TempNode out(Node n){return optimize(convertT((ArrayList)out.get(n)));}

  private boolean contain(Temp.TempNode h,Temp.Temp p){
    if(h==null) return false;
    if(p==h.head) return true;
    return contain(h.tail,p);
  }

  public Assem.Instr getInstr(Node x){return (Assem.Instr)ntoi.get(x);}

  private Temp.TempNode convertT(ArrayList a){
    ArrayList app=new ArrayList();
    for(int i=0;i<a.size();i++)app.add((Temp.Temp)a.get(i));
    return cconvertT(app);
  }

  private Temp.TempNode cconvertT(ArrayList a){
    if(a.size()>0){
      Temp.Temp app=(Temp.Temp)a.get(0);
      a.remove(0);
      return new Temp.TempNode(app,convertT(a));
    }
    return null;
  }
  private TempNode optimize(TempNode t){
    if(t==null)return null;
    if(t.head==null) return optimize(t.tail);
    return new TempNode(t.head,optimize(t.tail));
  }
}
