package Pentium;


public class Codegen
{
  PFrame frame;
  private Assem.InstrNode ilist=null,last=null;

  public Codegen(PFrame f) { frame = f; }

  private void emit(Assem.Instr inst){
    if (last!=null) last=last.tail=new Assem.InstrNode(inst,null);
    else last=ilist=new Assem.InstrNode(inst,null);
  }

  void munchStm(Tree.Stm s){
  if (s instanceof Tree.SEQ)  { munchStm((Tree.SEQ)s); return;}
  if (s instanceof Tree.LABEL) { munchStm((Tree.LABEL)s);return;}
  if (s instanceof Tree.EXP2) { munchStm((Tree.EXP2) s);  return;}
  if (s instanceof Tree.MOVE) {munchStm((Tree.MOVE)s);return;}
  if (s instanceof Tree.CJUMP){ munchStm((Tree.CJUMP)s);return;}
  if (s instanceof Tree.JUMP) {munchStm((Tree.JUMP)s);return;}
  System.out.println ("Tree.Stm "  + s.getClass() +"  non gestito");

}
  
  void munchStm(Tree.EXP2 s) {
    //EXP(CALL) (PROCEDURA)
    if (s.exp instanceof Tree.CALL) {
       Tree.CALL c = (Tree.CALL)s.exp;
       int n = 0;
        for (Tree.ExpList q = c.args;q!=null; q = q.tail) n++;
        n *= frame.wordSize();
        if (c.func instanceof Tree.NAME) {
        emit (new Assem.OPER("pushal\n",null,null));        
        munchArgs(0,c.args);
        emit (new Assem.OPER("call `j0\n",L(PFrame.SP,null),L(PFrame.SP,null),new Temp.LabelList(((Tree.NAME)c.func).label,null)));
        emit (new Assem.OPER("addl $" + n +",%`s0\n" ,L(PFrame.SP,null),L(PFrame.SP,null))); 
        emit (new Assem.OPER("popal\n",null,null));        
        return;
      } 
     System.out.println ("caso CALL non gestito");
     
    }
    //EXP(e1)
    else munchExp(s.exp);
  }
  
  
  void munchStm(Tree.LABEL s) {
    emit (new Assem.LABEL( "_" + s.label.toString() +":\n",s.label)); 
  }
  
    void munchStm(Tree.CJUMP s) {
    
   emit (new Assem.OPER("cmpl %`s1,%`s0\n",null,L(munchExp(s.left),L(munchExp(s.right),null)))); 
    if (s.relop == Tree.CJUMP.EQ)  
    emit (new Assem.OPER("je `j0\n",null,null,new Temp.LabelList(s.iftrue,new Temp.LabelList(s.iffalse,null))));
    if (s.relop == Tree.CJUMP.NE)
    emit (new Assem.OPER("jne `j0\n",null,null,new Temp.LabelList(s.iftrue,new Temp.LabelList(s.iffalse,null))));
    if (s.relop == Tree.CJUMP.LT)
    emit (new Assem.OPER("jl `j0\n",null,null,new Temp.LabelList(s.iftrue,new Temp.LabelList(s.iffalse,null))));
    if (s.relop == Tree.CJUMP.GT)
    emit (new Assem.OPER("jg `j0\n",null,null,new Temp.LabelList(s.iftrue,new Temp.LabelList(s.iffalse,null))));
    if (s.relop == Tree.CJUMP.LE)
    emit (new Assem.OPER("jle `j0\n",null,null,new Temp.LabelList(s.iftrue,new Temp.LabelList(s.iffalse,null))));
    if (s.relop == Tree.CJUMP.GE)
    emit (new Assem.OPER("jge `j0\n",null,null,new Temp.LabelList(s.iftrue,new Temp.LabelList(s.iffalse,null))));
  }


  void munchStm(Tree.SEQ s) {
    munchStm(s.left);
    munchStm(s.right);
  }


  void munchStm(Tree.JUMP s) {
    if (s.exp instanceof Tree.NAME)
    emit (new Assem.OPER("jmp `j0\n",null,null,s.targets));
    else System.out.println("Jump non prevista, " + s.exp.getClass()); 
  }

  void munchStm(Tree.MOVE s){
  //MOVE(MEM(BINOP(PLUS,e1,CONST),e2) 
    if (s.dst instanceof Tree.MEM && ((Tree.MEM) s.dst).exp instanceof Tree.BINOP
    && ((Tree.BINOP)((Tree.MEM)s.dst).exp).right instanceof Tree.CONST ) {
       int v;
       Tree.BINOP t = (Tree.BINOP)((Tree.MEM)s.dst).exp;
       v = ((Tree.CONST)t.right).value;   
       emit (new Assem.OPER("movl %`s1," + v + "(%`s0)\n",null,L(munchExp(t.left),L(munchExp(s.src),null))));
       return;
   }
  //MOVE(MEM(e1),e2)
  if (s.dst instanceof Tree.MEM ) {
      emit (new Assem.OPER("movl %`s1,(%`s0)\n",null,L(munchExp(((Tree.MEM)s.dst).exp),L(munchExp(s.src),null)) ));
      return;
  }
  //MOVE(e1,e2)
  emit (new Assem.MOVE("movl %`s0,%`d0\n",munchExp(s.dst),munchExp(s.src)));

  //System.out.println ("MOVE(" + s.dst.getClass() + "," +s.src.getClass() +")  non gestito");
  }


  Temp.Temp munchExp(Tree.Exp e){
  if (e instanceof Tree.BINOP) return munchExp((Tree.BINOP) e);
  if (e instanceof Tree.MEM) return munchExp((Tree.MEM) e);
  if (e instanceof Tree.TEMP) return munchExp((Tree.TEMP) e);
  if (e instanceof Tree.CONST) return munchExp((Tree.CONST) e);
  if (e instanceof Tree.CALL) return munchExp((Tree.CALL) e);
  if (e instanceof Tree.SNAME) return munchExp((Tree.SNAME) e);
  if (e instanceof Tree.NAME) return munchExp((Tree.NAME) e);
System.out.println ("Tree.exp" +  e.getClass() +"  non gestito");
  return null;
  }


  Temp.Temp munchExp(Tree.CONST e) {
  Temp.Temp r = new Temp.Temp();
  emit (new Assem.OPER("movl $" + e.value + ",%`d0\n",L(r,null),null)); 
  return r;
  }  

  Temp.Temp munchExp(Tree.TEMP e) {
  return e.temp;  
  }  

Temp.Temp munchExp(Tree.SNAME t) {
 Temp.Temp d = new Temp.Temp();
  String st = t.label.toString();
      emit (new Assem.OPER("movl $_" + st +",%`d0\n",L(d,null),null));
    return d;
} 

 Temp.Temp munchExp(Tree.MEM e){
  //MEM(BINOP(plus,e1,const))
  if (e.exp instanceof Tree.BINOP && ((Tree.BINOP)e.exp).right instanceof Tree.CONST) {
        Tree.BINOP  ex = (Tree.BINOP) e.exp;
        int i = ((Tree.CONST)ex.right ).value;
        Temp.Temp r = new Temp.Temp();
        emit (new Assem.OPER("movl " + i + "(%`s0),%`d0\n",L(r,null),L(munchExp(ex.left),null))); 
        return r;
  } 
  //MEM(e1)
  Temp.Temp r = new Temp.Temp();
  emit (new Assem.OPER("movl (%`s0),%`d0\n",L(r,null),L(munchExp(e.exp),null ))); 
  return r;  
  }

  
  
  Temp.Temp munchExp(Tree.BINOP e){
   //BINOP(op,const,const)  
   if (e.right instanceof Tree.CONST && e.left instanceof Tree.CONST
   	&& e.binop != Tree.BINOP.AND && e.binop != Tree.BINOP.OR) {
              Temp.Temp r=new Temp.Temp();
              int  c1 = ((Tree.CONST) e.left).value;
              int  c2 = ((Tree.CONST) e.right).value;
              int c=0;
              if (e.binop==Tree.BINOP.PLUS) c = c1 + c2;             
              if (e.binop==Tree.BINOP.MINUS) c = c1 - c2;             
              if (e.binop==Tree.BINOP.MUL) c = c1 * c2;
              if (e.binop==Tree.BINOP.DIV) c = c1 / c2;
              emit (new Assem.OPER("movl $"+c+",%`d0\n",L(r,null),null)); 
              return r;
   }
   
   //BINOP(op,e1,const)  
   if (e.right instanceof Tree.CONST 
   	&& e.binop != Tree.BINOP.MUL && e.binop != Tree.BINOP.DIV)  {
              Temp.Temp r= null,s=new Temp.Temp();
              int  c = ((Tree.CONST) e.right).value;
              r = munchExp(e.left);
              emit (new Assem.MOVE("movl %`s0,%`d0\n",s,r)); 
              if (e.binop==Tree.BINOP.PLUS)              
              emit (new Assem.OPER("addl $" + c + ",%`d0\n",L(s,null),L(s,null))); 
              if (e.binop==Tree.BINOP.MINUS)              
              emit (new Assem.OPER("subl $" + c + ",%`d0\n",L(s,null),L(s,null))); 
              if (e.binop==Tree.BINOP.AND)
              emit (new Assem.OPER("andl $" + c + ",%`d0\n",L(s,null),L(s,null))); 
              if (e.binop==Tree.BINOP.OR)
              emit (new Assem.OPER("orl $" + c  + ",%`d0\n",L(s,null),L(s,null))); 
  
              return s;
   } 
   //BINOP(MUL,e1,const) e BINOP(MUL,const,e2)
   if ((e.right instanceof Tree.CONST || e.left instanceof Tree.CONST)
   	&& (e.binop == Tree.BINOP.MUL))  {
              if (e.right instanceof Tree.CONST) {
                   Temp.Temp r = new Temp.Temp();
                   int  c = ((Tree.CONST) e.right).value;
                   emit (new Assem.OPER("imull $" + c + ",%`s0,%`d0\n",L(r,null),L(munchExp(e.left),null))); 
                   return r; 
              } 
              if (e.left instanceof Tree.CONST) {
                   Temp.Temp r = new Temp.Temp();
                   int  c = ((Tree.CONST) e.left).value;
                   emit (new Assem.OPER("imull $" + c + ",%`s0,%`d0\n",L(r,null),L(munchExp(e.right),null))); 
                   return r; 
              } 
   } 
   
   //BINOP(op,e1,e2)  
   if (e.binop != Tree.BINOP.MUL && e.binop != Tree.BINOP.DIV) {
              Temp.Temp r= null,s=null,t = new Temp.Temp();
              r = munchExp(e.left);
              emit (new Assem.MOVE("movl %`s0,%`d0\n",t,r)); 
              if (e.binop==Tree.BINOP.PLUS) 
              emit (new Assem.OPER("addl %`s1,%`d0\n",L(t,null),L(t,L(munchExp(e.right),null)))); 
              if (e.binop==Tree.BINOP.MINUS)
              emit (new Assem.OPER("subl %`s1,%`d0\n",L(t,null),L(t,L(munchExp(e.right),null)))); 
              if (e.binop==Tree.BINOP.AND)
              emit (new Assem.OPER("andl %`s1,%`d0\n",L(t,null),L(t,L(munchExp(e.right),null)))); 
              if (e.binop==Tree.BINOP.OR)
              emit (new Assem.OPER("orl %`s1,%`d0\n",L(t,null),L(t,L(munchExp(e.right),null)))); 
              
              return t;
                
   
   }       
   //BINOP(MUL,e1,e2)  
   if (e.binop==Tree.BINOP.MUL) {                  
              Temp.Temp r = munchExp(e.left);
              emit (new Assem.OPER("imull %`s1,%`d0\n",L(r,null),L(r,L(munchExp(e.right),null)))); 
              return r; 
   }
   
   //BINOP(DIV,e1,e2)  
   if (e.binop==Tree.BINOP.DIV) {                  
              Temp.Temp r = new Temp.Temp();
              Temp.Temp s = new Temp.Temp();              
              emit (new Assem.MOVE("movl %`s0,%`d0\n",r,munchExp(e.left))); 
              emit (new Assem.MOVE("movl %`s0,%`d0\n",s,munchExp(e.right))); 
              emit (new Assem.OPER("movl $0,%`d0\n",L(PFrame.EDX,null),null)); 
              emit (new Assem.MOVE("movl %`s0,%`d0\n",PFrame.EAX,r)); 
              emit (new Assem.OPER("cdq\n",null,null));
              emit (new Assem.OPER("idivl %`s1\n",L(PFrame.EAX,L(PFrame.EDX,null)),L(PFrame.EAX,L(s,L(PFrame.EDX,null))))); 
             
              return PFrame.EAX;
  }
                 
  return null;
  }

Temp.Temp munchExp(Tree.NAME n)  {
  Temp.Temp r = new Temp.Temp();
  String s = ((Temp.Label)n.label).toString();
  emit (new Assem.OPER("movl _" + s+ ",%`d0\n",L(r,null),null ));
  return r;
} 



Temp.Temp munchExp(Tree.CALL c) {
        if (c.func instanceof Tree.NAME) {
        Temp.Temp t = new Temp.Temp();
        int n = 0;
        for (Tree.ExpList q = c.args;q!=null; q = q.tail) n++;
        n *= frame.wordSize();

        emit (new Assem.OPER("pushal\n",null,null));        

        munchArgs(0,c.args);
        emit (new Assem.OPER("call `j0\n",L(PFrame.RV,L(PFrame.SP,null)),L(PFrame.SP,null),new Temp.LabelList(((Tree.NAME)c.func).label,null)));
        emit (new Assem.OPER("addl $" + n + ",%`s0\n",L(PFrame.SP,null),L(PFrame.SP,null)));         


        emit (new Assem.OPER("movl %eax,_RV\n" ,null,null));         
        emit (new Assem.OPER("popal\n",null,null));        
        emit (new Assem.OPER("movl _RV,%`d0\n" ,L(t,null),null));  

        return t;
      }  
  System.out.println ("caso CALL non gestito");
  return null;
  }
  


  //spostiamo tutti gli argomenti dall'i-esimo in poi nel frame
  void  munchArgs(int i,Tree.ExpList e){
    int k =0;
   Tree.ExpList e1 = reverse(e); 
   for (Tree.ExpList p = e1;p!=null;p=p.tail) {
      if (k >= i) { 
      emit (new Assem.OPER("pushl %`s0\n",L(PFrame.SP,null),L(munchExp(p.head),L(PFrame.SP,null))));
      }	
      k++;
    }
  }
   
  

 private String getOp (int binop,int c) {
  if (binop == Tree.BINOP.PLUS && c >= 0) return "+";
  if (binop == Tree.BINOP.PLUS && c < 0)  return "-";
  if (binop == Tree.BINOP.MINUS && c >= 0) return "-";
  if (binop == Tree.BINOP.MINUS && c < 0) return "+";
  return null;
  }


  public Assem.InstrNode codegen(Tree.Stm s){
    Assem.InstrNode l;
    munchStm(s);
    l=ilist;
    ilist=last=null;
    return l;
  }
 
  Temp.TempNode L(Temp.Temp h,Temp.TempNode t) { return new Temp.TempNode(h,t);}

  Tree.ExpList reverse(Tree.ExpList il){
  	Tree.ExpList j = null;
  	while(il != null){
  		j = new Tree.ExpList(il.head,j);
  		il = il.tail;
  	}
  	return j;
  }
}