package Pentium;

public class PFrame extends Frame.Frame implements Temp.TempMap
{
  public static final int wS=4;// la wordsize
  public static final Temp.Temp FP=new Temp.Temp();
  public static final Temp.Temp SP=new Temp.Temp();
  public static final Temp.Temp EAX=new Temp.Temp();
  public static final Temp.Temp EBX=new Temp.Temp();
  public static final Temp.Temp ECX=new Temp.Temp();
  public static final Temp.Temp EDX=new Temp.Temp();
  public static final Temp.Temp ESI =new Temp.Temp();
  public static final Temp.Temp EDI=new Temp.Temp();
  public static final Temp.Temp EFLAGS =new Temp.Temp();
  public static final Temp.Temp RV = EAX;

  public int nVarLocal;
  
  private int cont;


  public Frame.Frame newFrame(Temp.Label name, Util.BoolList formals){
    PFrame f=new PFrame();
    f.nVarLocal=0;
    f.name=name;    
    f.cont=wS*2;
    f.formals=f.accessFromBool(formals);
    f.main=false;
    return f;
  }
  
  public Temp.TempNode registers(){
    return 
        new Temp.TempNode(EAX,
            new Temp.TempNode(EBX,
                new Temp.TempNode(ECX,
                    new Temp.TempNode(EDX,
                        new Temp.TempNode(ESI,
                            new Temp.TempNode(EDI,
                                new Temp.TempNode(SP,
                                    new Temp.TempNode(FP,
                                            null))))))));
  }

  public Frame.Access allocLocal(boolean escape){
    if(escape){
      countAlloc++;
      InFrame ret=new InFrame();
      nVarLocal++;
      ret.offset=-countAlloc*wS;
      return ret;
    }
    return new InReg();    
  }

  private AccessList accessFromBool(Util.BoolList ll){
    if(ll==null)return null;
    Frame.Access n;
    if(ll.head){ n=new InFrame();((InFrame)n).offset=cont; cont+=wS;}
    else n=new InReg();
    return new AccessList(n,accessFromBool(ll.tail));
  }

  public Temp.Temp FP(){return FP;}

  public int wordSize(){return wS;}

  public int staticLinkOffset() {return 8;}

  public Temp.Temp RV(){return RV;}

  public String string(Temp.Label l,String g){
    return new String("_"+l+":\n .byte "+toByteString(g)+"\n");
  }

  public static String toByteString(String a){
    byte [] app=a.getBytes();
    String ret="";
    for(int i=0;i<app.length;i++)ret+=app[i]+",";
    ret+="0";
    return ret;
  }

  public Tree.Stm procEntryExit1(Tree.Stm body){
    return body;
  }

  public Proc procEntryExit3(Assem.InstrNode body){    
    return new Proc(this,body);
  }

  public Assem.InstrNode codegen(Tree.Stm stm){ return (new Codegen(this)).codegen(stm);}

  public String tempMap(Temp.Temp t){
    if (t == EAX) return "eax";
    if (t == EBX) return "ebx";
    if (t == ECX) return "ecx";
    if (t == EDX) return "edx";
    if (t == EDI) return "edi";     
    if (t == ESI) return "esi";     
    if (t == FP) return "ebp";      
    if (t == SP) return "esp";      
    return null;  
  }

  public Tree.Exp externalCall(String s, Tree.ExpList args)
  {
    Temp.Label nn = (Temp.Label)extRoutine.get(s);
    if(nn == null) {
        System.err.println("[errore interno] '"+s+"' non e' una funzione di libreria del Tiger");
        return new Tree.CALL(new Tree.NAME(new Temp.Label(s)),args);
    }
    return new Tree.CALL(new Tree.NAME(nn),args);
  }
}
