package Semant;

import Symbol.*;
import Types.*;
import Translate.Level;

class Env
{
	Table venv;
	Table tenv;

	// predefined types to make them easy accesable
	public static final Types.Type _int = new INT();
	public static final Types.Type _string = new STRING();
	public static final Types.Type _nil = new NIL();
	public static final Types.Type _void = new VOID();
	
	public Env(Level root)
	{
		tenv = new Table();

		// put the predefined types also as symbols in the type environment
		tenv.put( Symbol.symbol("int"), _int );
		tenv.put( Symbol.symbol("string"), _string );
		tenv.put( Symbol.symbol("nil"), _nil );

		// void is no reserved word, it's just for internal use. so I put it out again
		//tenv.put( Symbol.symbol("void"), _void );

		venv = new Table();

		// FIX: rendere Env indipendente dalla libreria? (ie: nel costruttore di Semant passo un'istanza di Env in cui ho gia' messo la libreria,
		// oppure creo una classe derivata da Env in cui metto la libreria)
		// funzioni di libreria
        Level l = Level.extLevel(root, Symbol.symbol("printint"), new Util.BoolList(true,null));
        venv.put( Symbol.symbol("printint"), new FunEntry(l, 
                new RECORD(Symbol.symbol("i"), _int,  null ), 
                _void ) );
        Frame.Frame.extRoutine.put("printint", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("print"), new Util.BoolList(true,null));
		venv.put( Symbol.symbol("print"), new FunEntry(l, 
			new RECORD(Symbol.symbol("s"), _string,  null ), 
			_void ) );
        Frame.Frame.extRoutine.put("print", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("flush"), null);
		venv.put( Symbol.symbol("flush"), new FunEntry(l, null , _void ) );
        Frame.Frame.extRoutine.put("flush",l.frame.name);
		l = Level.extLevel(root, Symbol.symbol("getchar1"), null);
		venv.put( Symbol.symbol("getchar"), new FunEntry(l, null , _string ) );
        Frame.Frame.extRoutine.put("getchar1", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("ord"), new Util.BoolList(true,null));
		venv.put( Symbol.symbol("ord"), new FunEntry(l, 
			new RECORD(Symbol.symbol("s"), _string,  null ), _int ) );
        Frame.Frame.extRoutine.put("ord", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("chr"), new Util.BoolList(true,null));
		venv.put( Symbol.symbol("chr"), new FunEntry(l, 
			new RECORD(Symbol.symbol("i"), _int,  null ), _string ) );
        Frame.Frame.extRoutine.put("chr", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("size"), new Util.BoolList(true,null));
		venv.put( Symbol.symbol("size"), new FunEntry(l, 
			new RECORD(Symbol.symbol("s"), _string,  null ), _int ) );
        Frame.Frame.extRoutine.put("size", l.frame.name);
		l = Level.extLevel(root, Symbol.symbol("substring"), new Util.BoolList(true,new Util.BoolList(true,new Util.BoolList(true,null))));
		venv.put( Symbol.symbol("substring"), new FunEntry(l, 
			new RECORD(Symbol.symbol("s"), _string, 
			new RECORD(Symbol.symbol("first"), _int, 
			new RECORD(Symbol.symbol("n"), _int,  null ))), _string ) );
        Frame.Frame.extRoutine.put("substring", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("concat"), new Util.BoolList(true,new Util.BoolList(true,null)));
		venv.put( Symbol.symbol("concat"), new FunEntry(l, 
			new RECORD(Symbol.symbol("s1"), _string, 
			new RECORD(Symbol.symbol("s2"), _string,  null ) ), _string ) );
        Frame.Frame.extRoutine.put("concat", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("not"), new Util.BoolList(true,null));
		venv.put( Symbol.symbol("not"), new FunEntry(l, 
			new RECORD(Symbol.symbol("i"), _int,  null ), _int ) );
        Frame.Frame.extRoutine.put("not", l.frame.name);
        l = Level.extLevel(root, Symbol.symbol("exit"), new Util.BoolList(true,null));
		venv.put( Symbol.symbol("exit"), new FunEntry(l, 
			new RECORD(Symbol.symbol("i"), _int,  null ), _void ) );
        Frame.Frame.extRoutine.put("exit", l.frame.name);
        // funzioni riservate (inserite nel codice intermedio)
        l = Level.extLevel(root, Symbol.symbol("stringEqual"), new Util.BoolList(true,new Util.BoolList(true,new Util.BoolList(true,null))));
        venv.put( Symbol.symbol("stringEqual"), new FunEntry(l,
            new RECORD(Symbol.symbol("i") , _int,
            new RECORD(Symbol.symbol("s0"), _string, 
            new RECORD(Symbol.symbol("s1"), _string, null ))), _int ) );
        Frame.Frame.extRoutine.put("stringEqual", l.frame.name);
        l = Level.extLevel(root,Symbol.symbol("malloc"),new Util.BoolList(true,null));
        venv.put(Symbol.symbol("malloc"), new FunEntry(l,
            new RECORD(Symbol.symbol("i"), _int, null ), _int) ); 
        Frame.Frame.extRoutine.put("malloc", l.frame.name);
        l = Level.extLevel(l, Symbol.symbol("initArray"),new Util.BoolList(true,new Util.BoolList(true,null)));
        venv.put( Symbol.symbol("initArray"), new FunEntry(l,
            new RECORD(Symbol.symbol("i"), _int, null ), _int ) ); 
        Frame.Frame.extRoutine.put("initArray", l.frame.name);
    }
}
