@echo off

rem ----------------------------------------------------------
rem
rem make.bat - compile JOTTO source files
rem
rem ----------------------------------------------------------

rem names of files: %LANGFILE%.lex and %LANGFILE%.cup

rem to free environment space
set classpath=

set LANGFILE=Tiger
set OUTCUP=./debug/_out_cup.txt
set OUTLEX=./debug/_out_lex.txt
set JFLAGS=-g -deprecation -nowarn
set MAINCLASS=Main/Jotto
set EDMAINCLASS=Editor/JOTTOEditor

goto begin

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE

:usage
	echo.
	echo Usage:
	echo         make [lex[+]] [parse[+]] [comp] [all]
	echo.
	echo   lex    - generates lexer (+ includes parse and comp)
	echo   parse  - generates parser (+ include comp)
	echo   comp   - compiles JOTTO  files
	echo   editor - compiles Editor files
	echo   all    - generates all java files and compiles them
	echo.
goto end

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE

:begin
	goto init
	:initEND

	goto params
	:paramsEND

	if "%lex%"=="1" goto lex
	:lexEND

	if "%parse%"=="1" goto parse
	:parseEND

	if "%comp%"=="1" goto comp
	:compEND

	if "%editor%"=="1" goto editor
	:editorEND

	goto clrpar
	:clrparEND

goto done


echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE


:params
	if not "%1"=="lex" goto Plex
		set lex=1
		goto doShift
	:Plex
	if not "%1"=="lex+" goto Plex_
		set lex=1
		set parse=1
		goto doShift
	:Plex_
	if not "%1"=="lex++" goto Plex__
		set lex=1
		set parse=1
		set comp=1
		goto doShift
	:Plex__
	if not "%1"=="parse" goto Pparse
		set parse=1
		goto doShift
	:Pparse
	if not "%1"=="parse+" goto Pparse_
		set parse=1
		set comp=1
		goto doShift
	:Pparse_
	if not "%1"=="parse++" goto Pparse__
		set parse=1
		set comp=1
		set editor=1
		goto doShift
	:Pparse__
	if not "%1"=="comp" goto Pcomp
		set comp=1
		goto doShift
	:Pcomp
	if not "%1"=="comp+" goto Pcomp_
		set comp=1
		set editor=1
		goto doShift
	:Pcomp_
	if not "%1"=="editor" goto Peditor
		set editor=1
		goto doShift
	:Peditor
	if not "%1"=="editor+" goto Peditor_
		set editor=1
		goto doShift
	:Peditor_

	if not "%1"=="all" goto Pgo
		set lex=1
		set parse=1
		set comp=1
		set editor=1
		goto doShift
	:Pgo

	:doShift
	shift
	if not "%1x"=="x" goto params
goto paramsEND

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE


:init
		if "%1x"=="x" goto usage
		echo ----init...
		set lex=
		set parse=
		set clean=
		set comp=
		set editor=
goto initEND

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE


:clrpar
		set lex=
		set parse=
		set clean=
		set comp=
		set editor=
goto clrparEND

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE

:lex
	echo ----gererate Lexer...
	@echo on
	java JLex.Main Main\%LANGFILE%.lex > %OUTLEX%
	@echo off
	move Main\%LANGFILE%.lex.java parse\Yylex.java>>%OUTLEX%
goto lexEND

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE


:parse
	echo ----gererate Parser...
	@echo on
	java java_cup.Main -package Parse < Main\%LANGFILE%.cup > %OUTCUP%
	@echo off
	move parser.java parse\>>%OUTCUP%
	move sym.java parse\>>%OUTCUP%
goto parseEND

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE


:comp
	echo ----compile...
	rem cleanup
	del Absyn\*.class
	del Assem\*.class
	del Canon\*.class
	del ErrorMsg\*.class
	del FlowGraph\*.class
	del Frame\*.class
	del Graph\*.class
	del Main\*.class
	del Parse\*.class
	del Pentium\*.class
	del RegAlloc\*.class
	del Semant\*.class
	del Symbol\*.class
	del Temp\*.class
	del Translate\*.class
	del Tree\*.class
	del Types\*.class
	del Util\*.class
	@echo on
	javac %JFLAGS% %MAINCLASS%.java
	@echo off
goto compEND

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE


:editor
	del Editor\*.class
	@echo on
	javac %JFLAGS% %EDMAINCLASS%.java
	@echo off
goto editorEND

echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR in BATCH FILE


:done
	echo.
	echo ----done.
	echo.
:end
pause